-----------------------------------------------------------------------------
-- contador de 5 bits
-----------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

	entity contador is
		port( reset, clock : in bit;  saida : out std_logic_vector(4 downto 0));
	end contador;

architecture comportamental of contador is
	begin
		process (clock)
			variable count_value : std_logic_vector(4 downto 0);
		begin
		    if reset='1' or count_value>7 then 
		        count_value := (others => '0');
			elsif clock'event and clock = '1' then
			    count_value := count_value + 1;
				saida <= count_value;
			end if;
		end process;
end comportamental;


---------------------------------------------------------------
-----  test_bench
---------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

	entity tb is
	end tb;

	architecture teste of tb is
	
	component contador
	      port( clock,reset : in bit;  saida : out std_logic_vector(4 downto 0) );
	end component;
	
	signal ck,reset : bit;
	signal cont : std_logic_vector(4 downto 0) ;
	
	begin
	
	   cont1:  contador port map(clock=>ck, reset=>reset, saida=>cont);
	   
	   reset <= '1', '0' after 15ns ;
	   
	   -- gerador de clock
	   process
	    begin
	     ck <= '1' after 10ns, '0' after 20ns;
	     wait for 20ns;
	   end process;
	    
	end teste;
	
