------------------------------------ inversor
library IEEE;
use IEEE.std_logic_1164.all;

entity inversor is
      Port(a : in bit; y : out bit);
end inversor;

architecture comp of inversor is
	begin
		y <= not a;
end comp;

--------------------------------- flip flop T
library IEEE;
use IEEE.std_logic_1164.all;

entity Tflip_flop is
      Port(ck : in bit; q  : out bit);
end Tflip_flop;

architecture comp of Tflip_flop is
	signal regQ:bit;
	begin
		q<=regQ;    -- concorrente
		process (ck)
  			begin
    			if  (ck'event and ck='1') then regQ <= not regQ;
    			end if;
		end process;
end comp;



-----------------------------------------------------------------------------
-- contador de dois bits
-----------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

	entity contador is
		generic(prop_delay : Time := 2 ns);
		port( clock : in bit;  q1, q0 : out bit);
	end contador;

---------------------------------------------------------------
----- arquitetura comportamental com variavel
---------------------------------------------------------------
	architecture comportamental of contador is
	begin
		count_up: process (clock)
			variable count_value : natural := 0;
		begin
			if clock = '1' then
				count_value := (count_value + 1) mod 4;
				q0 <= bit'val(count_value mod 2) after prop_delay;
				q1 <= bit'val(count_value / 2) after prop_delay;
			end if;
		end process count_up;
	end comportamental;

---------------------------------------------------------------
----- arquitetura comportamental com sinal
---------------------------------------------------------------
	architecture com_sinal of contador is
	    signal contador : natural := 0;
	begin
		count_up: process (clock)	
		begin
			if clock = '1' then
				contador <= (contador + 1) mod 4;
				q0 <= bit'val(contador mod 2) after prop_delay;
				q1 <= bit'val(contador / 2) after prop_delay;
			end if;
		end process count_up;
	end com_sinal;
	
---------------------------------------------------------------
----- arquitetura ESTRUTURAL
---------------------------------------------------------------
   architecture estrutural of contador is
		component Tflip_flop
			port( ck: in bit; q: out bit);
		end component;
		component inversor
			port( a: in bit; y: out bit);
		end component;
		signal ff0, ff1, inv_ff0 : bit;
	begin
		bit_0: Tflip_flop port map( ck=> clock, q => ff0);
		inv: inversor port map( a=> ff0, y => inv_ff0);
		bit_1: Tflip_flop port map( ck=> inv_ff0, q => ff1);
		q0 <= ff0;
		q1 <= ff1;
	end estrutural;


---------------------------------------------------------------
-----  test_bench
---------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

	entity tb is
	end tb;

	architecture teste of tb is
	
	component contador
	      port( clock : in bit;  q1, q0 : out bit );
	end component;
	
	signal ck, q1, q0 : bit;
	
	begin
	
	   cont1:  contador port map(clock=>ck, q0=>q0, q1=>q1);
	   
	   -- gerador de clock
	   process
	    begin
	     ck <= '1' after 10ns, '0' after 20ns;
	     wait for 20ns;
	   end process;
	    
	end teste;
	
---------------------------------------------------------------
-----  configuracao, utilizando cada uma das arquiteturas
-- a configuracao se aplica ao test_bench, selecionando-se
-- neste qual das arquiteturas do contador serautilizada
---------------------------------------------------------------

configuration conf1 of tb is
     for teste
        for cont1 : contador
          -- use entity work.contador(comportamental);
          use entity work.contador(com_sinal);
          --use entity work.contador(estrutural);
        end for;
     end for; 
end conf1;


