--
--  mdc estrutural- PROVA P2 2001/1 - MORAES
--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;         
 
entity mdcEST is
 port ( n, m: in std_logic_vector(7 downto 0);
        reset, ck: in std_logic; 
        fim: out std_logic;
        saida: out std_logic_vector(7 downto 0)
      );
end mdcEST;

architecture a1 of mdcEST is
  signal mux1, mux2, mm, nn, resto: std_logic_vector(7 downto 0);           
  signal inicio, en: std_logic;
  type type_state  is (S0, S1, S2);  
  signal EA, PE :  type_state; 
begin
        
  mux1 <= n when inicio='1' else resto;
  mux2 <= m when inicio='1' else nn;       
          
  process(ck)     
  begin
     if ck'event and ck='1' then  
           if en='1' then
               mm <= mux2;  
               nn <= mux1;  
           end if;
     end if;          
  end process;
  
  resto <= mm mod nn;   -- no funciona na prtica o cdigo real est abaixo 
        
  -- 
  --  bloco de controle
  -- 
  en <=     '1' when EA=S0 or EA=S1 else '0';
  inicio <= '1' when EA=S0 else '0';      
  fim <=    '1' when EA=S2 else '0';  
  saida <=  nn  when EA=S2 else (others=>'0');
          
  process(ck,reset)
  begin
    if reset='1' then
            EA<=S0;
    elsif ck'event and ck='0' then
            EA<=PE;
    end if;
  end process;

  process(EA, resto)
  begin
    case(EA) is
     when S0 =>  PE <= S1;                           
     when S1 =>  if resto="00000000" then PE<=S2; else PE<=S1; end if;                                         
     when S2 =>  PE <= S2; 
   end case;
  end process;  
                
end a1;

--
--  TEST_BENCH
--
library ieee;
use IEEE.std_logic_1164.all;    
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

entity mdcb_tb is
end mdcb_tb;

architecture TB_ARCHITECTURE of mdcb_tb is
             
  component mdcEST
   port (
          n, m: in std_logic_vector(7 downto 0);
          reset, ck: in std_logic; 
          fim: out std_logic;
          saida: out std_logic_vector(7 downto 0)
        );
   end component;

   signal n,m,nref,mref, saida : std_logic_vector(7 downto 0);
   signal fim, ck, reset : std_logic;

begin

  UUT: mdcEST port map(n=>n, m=>m, ck=>ck, reset=>reset, fim=>fim, saida=>saida);

  nref  <= CONV_STD_LOGIC_VECTOR( 42, 8);
  mref  <= CONV_STD_LOGIC_VECTOR( 32, 8);
        
  process
    begin
       ck<='0', '1' after 10ns;
       wait for 20 ns;
  end process;
 
  reset<= '0', '1' after 8ns, '0' after 23 ns;
  
end TB_ARCHITECTURE;






--
--  cdigo do rem que funciona
--
  process(mm, nn)
  begin 
    if nn>"00000000" then
         resto <= CONV_STD_LOGIC_VECTOR( CONV_INTEGER(mm) rem CONV_INTEGER(nn), 8); 
    else 
        resto <= (others=>'0');
    end if;
  end process; 